config/routes.rb
Rails.application.routes.draw do

  resources :sessions, only: [:new, :create,  :destroy]

  resources :books do
    resources :notes, only:[:create, :destroy, :edit]
  end
  root 'books#index'

  get "/login" => "sessions#new", as: "login"
  delete "/logout" => "sessions#destroy", as: "logout"

end

app/models/book.rb
class Book < ActiveRecord::Base
  belongs_to :reviewer
  has_many :notes, dependent: :destroy
end

app/models/note.rb
class Note < ActiveRecord::Base
  belongs_to :book
end

app/models/reviewer.rb
class Reviewer < ActiveRecord::Base
  has_many :books
  has_secure_password


end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  before_action :ensure_login

  helper_method :logged_in?, :current_user

  def logged_in?

    session[:reviewer_id]

  end

  def current_user
    @current_user ||= Reviewer.find(session[:reviewer_id])

  end

  protected
  def ensure_login
    redirect_to login_path unless session[:reviewer_id]

    end

  end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  #esto reemplaza lo del find y es lo que primero se ejecuta
  before_action :set_book, only: [:show, :edit, :update, :destroy]

  # GET /books
  # GET /books.json
  def index
    @books = current_user.books
  end

  # GET /books/1
  # GET /books/1.json
  def show
  end

  #GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books
  # POST /books.json
  def create
    @book = current_user.books.new(book_params)

    respond_to do |format|
      if @book.save
        format.html { redirect_to @book, notice: 'Book was successfully created.' }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1
  # PATCH/PUT /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to @book, notice: 'Book was successfully updated.' }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1
  # DELETE /books/1.json
  def destroy
    @book.destroy
    respond_to do |format|
      format.html { redirect_to books_url, notice: 'Book was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_book
      @book = Book.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def book_params
      params.require(:book).permit(:name, :author)
    end
end

app/controllers/notes_controller.rb
class NotesController < ApplicationController
  before_action :set_book, only: [:create, :destroy]

def create
  @note = @book.notes.new(note_params)
  if @note.save
    redirect_to @book, notice: "Note successfully added!"
  else
    redirect to @book, alert: "Unable to add note!"
  end
end

def destroy
  @note = @book.notes.find(params[:id])
  @note.destroy
  redirect_to @book, notice: "Note deleted!"
end

private
  def set_book
    @book = Book.find(params[:book_id])
  end

  def note_params
    params.require(:note).permit(:title, :note)
  end

end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  skip_before_action :ensure_login, only: [:new, :create]
  def new
  end

  def create
    reviewer = Reviewer.find_by(name: params[:reviewer][:name])
    password = params[:reviewer][:password]

    if reviewer && reviewer.authenticate(password)
      session[:reviewer_id] = reviewer.id
      redirect_to root_path, notice: "Logged in successfully"
    else
      redirect_to login_path, alert: "Invalid username/password"
    end
  end

  def destroy
    reset_session
    redirect_to login_path, notice: "You have been logged out"
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/notes_helper.rb
module NotesHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper
end

app/views/books/_form.html.erb
<%= form_for(@book) do |f| %>
  <% if @book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@book.errors.count, "error") %> prohibited this book from being saved:</h2>

      <ul>
      <% @book.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <br><br>
    <div class="row  center-align col s4">
      <div class="col s4 ">
        <h2></h2>
      </div>
      <div class="col s4 z-depth-4 card-panel">
        <form class="login-form">
          <div class="row">
            <div class="input-field col s12 center">
              <p class="center login-form-text"><h2 class="gray-text">New Book</h2></p>
            </div>
          </div>
          <div class="row margin">
            <div class="input-field col s12">
              <i class="mdi-av-my-library-books prefix"></i>

                  <%= f.text_field :name, :placeholder => "Title" %>

              </div>
          </div>
          <div class="row margin">
            <div class="input-field col s12">
              <i class="mdi-social-person-outline prefix"></i>

              <%= f.text_field :author, :placeholder => "Author" %>
            </div>
          </div>
          <div class="row">
            <div class="input-field col s6">
              <div class="actions">
                <%= f.submit "Save",  class:"waves-effect waves-light btn"%>
              </div>
             </div>
             <div class="input-field col s6">
               <div class="actions">
                 <%= link_to 'Back', books_path, class:"waves-effect waves-light btn" %>
               </div>

             </div>
          </div>
        </form>
      </div>
    </div>

<% end %>

app/views/books/edit.html.erb
<%= form_for(@book) do |f| %>
  <% if @book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@book.errors.count, "error") %> prohibited this book from being saved:</h2>

      <ul>
      <% @book.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <br><br>
    <div class="row  center-align col s4">
      <div class="col s4 ">
        <h2></h2>
      </div>
      <div class="col s4 z-depth-4 card-panel">
        <form class="login-form">
          <div class="row">
            <div class="input-field col s12 center">
              <p class="center login-form-text"><h2 class="gray-text">Editing Book</h2></p>
            </div>
          </div>
          <div class="row margin">
            <div class="input-field col s12">
              <i class="mdi-av-my-library-books prefix"></i>

                  <%= f.text_field :name, :placeholder => "Title" %>

              </div>
          </div>
          <div class="row margin">
            <div class="input-field col s12">
              <i class="mdi-social-person-outline prefix"></i>

              <%= f.text_field :author, :placeholder => "Author" %>
            </div>
          </div>
          <div class="row">
            <div class="input-field col s4">
              <div class="actions">
                <%= f.submit "Save",  class:"waves-effect waves-light btn"%>
              </div>
             </div>
             <div class="input-field col s4">
               <div class="actions">
                 <%= link_to 'Show', @book, class:"waves-effect waves-light btn" %>
               </div>

             </div>
             <div class="input-field col s4">
               <div class="actions">
                 <%= link_to 'Back', books_path, class:"waves-effect waves-light btn" %>
               </div>

             </div>

          </div>
        </form>
      </div>
    </div>

<% end %>

app/views/books/index.html.erb
<center><h1>Listing Books</h1></center>

<table class="highlight responsive-table">
  <%= link_to ' New Book', new_book_path %>
  <thead>
    <tr>
      <th>Name</th>
      <th>Author</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @books.each do |book| %>
      <tr>
        <td><%= book.name %></td>
        <td><%= book.author %></td>
        <td><%= link_to 'Show', book %></td>
        <td><%= link_to 'Edit', edit_book_path(book) %></td>
        <td><%= link_to 'Destroy', book, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

app/views/books/new.html.erb
<%= render 'form' %>

app/views/books/show.html.erb
<div class="book">
  <%= content_tag :span, "#{@book.name} (#{@book.author})", class: "book-title" %>
  <%= link_to 'Edit', edit_book_path(@book) %>
</div>

<div id="notes">
  <%= render @book.notes %>
</div>

<div>
  <%= form_for([@book, @book.notes.new]) do |f| %>
    <div class="field">
      <%= f.label :title %>
      <%= f.text_field :title %>
    </div>
    <div class="field">
      <%= f.label :note %>
      <%= f.text_area :note, size: "25x5" %>
    </div>
    <div class="actions">
      <%= f.submit "Add New Note" %>
    </div>
  <% end %>
</div>

<%= link_to 'Back', books_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>IReviwed</title>

  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>



  <div class="navbar-fixed">
  <nav>
    <div class="nav-wrapper teal lighten-2">
      <a href="#!" class="brand-logo">BOOKS</a>
      <ul class="right hide-on-med-and-down">

        <li>  <% if logged_in? %>
          <div style='float: right; white-text'>
              <%= current_user.name %></li>
            <li>  <%= link_to '<i class="mdi-content-clear"> </i>'.html_safe, logout_path, method: :delete %></li>
          </div>
          <% end %>
      </ul>
    </div>
  </nav>
</div>


<center><% flash.each do |key, value|%>
<p id= '<%=key%>' >
  <%= value %>
</p>

<%end%></center>
<div class="contenedor">
<%= yield %>

</div>

<footer class="page-footer teal lighten-2">
         <div class="container">
           <div class="row">
             <div class="col l6 s12">
               <h5 class="white-text">Footer</h5>
               <p class="grey-text text-lighten-4">Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et.</p>
             </div>
           </div>
         </div>
         <div class="footer-copyright">
           <div class="container">
           © 2014 Copyright Text
           </div>
         </div>
       </footer>

</body>

       <!-- jQuery Library -->
       <script type="text/javascript" src="js/plugins/jquery-1.11.2.min.js"></script>
       <!--materialize js-->
       <script type="text/javascript" src="js/materialize.min.js"></script>
       <!--prism-->
       <script type="text/javascript" src="js/plugins/prism/prism.js"></script>
       <!--scrollbar-->
       <script type="text/javascript" src="js/plugins/perfect-scrollbar/perfect-scrollbar.min.js"></script>

           <!--plugins.js - Some Specific JS codes for Plugin Settings-->
         <script type="text/javascript" src="js/plugins.min.js"></script>
         <!--custom-script.js - Add your own theme custom JS-->
         <script type="text/javascript" src="js/custom-script.js"></script>
</html>

app/views/notes/_note.html.erb
<div class="note">
  <div>
    <%= content_tag :span, "#{note.title} (#{time_ago_in_words note.created_at} ago)", 
      class: "note-title" %>
    <%= link_to "Delete Note", [@book, note], method: :delete %>
  </div>
  <div><%= simple_format note.note %></div>
</div>